<template>
  <v-card class="pa-2" tile>
    <v-autocomplete
      v-model="choosenAirports"
      label="Airports"
      hide-no-data
      clearable
      chips
      deletable-chips
      multiple
      :items="airports"
      :loading="loading"
      :search-input.sync="search"
    ></v-autocomplete>
    <v-virtual-scroll height="200px" :items="choosenAirports" item-height="64">
      <template v-slot="{ item }">
        <v-list-item :key="item">
          <v-list-item-content>
            <div
              style="color: white;"
              class="pa-3 primary text-no-wrap rounded-pill"
            >
              {{ item }}
            </div>
          </v-list-item-content>

          <v-list-item-action>
            <div>
              <v-badge class="mx-1 adult" bordered content="1" overlap>
                <v-icon large>mdi-account-tie</v-icon>
              </v-badge>
              <div style="display: none;" class="adultAction">
                <p>+</p>
                <p>-</p>
              </div>
              <v-badge class="mx-1 child" bordered content="0" overlap>
                <v-icon large>mdi-human-male-boy</v-icon>
              </v-badge>
              <div style="display: none;" class="adultAction">
                <button>+</button>
                <button>+</button>
              </div>

              <v-icon class="mx-1" large>mdi-close</v-icon>
            </div>
          </v-list-item-action>
        </v-list-item>

        <v-divider></v-divider>
      </template>
    </v-virtual-scroll>
  </v-card>
</template>

<script>
import debounce from "debounce";
import flightAPI from "../api/flight";

export default {
  name: "Airports",
  data: () => ({
    dates: [new Date().toISOString(), new Date().toISOString()],
    airports: [],
    loading: false,
    search: "",
    //
  }),
  computed: {
    choosenAirports: {
      get() {
        return this.$store.getters.getChoosenAirports;
      },
      set(value) {
        this.$store.dispatch("setChoosenAirports", value);
      },
    },
  },
  methods: {
    makeSearch: async (value, self) => {
      if (!value) {
        return;
      }
      if (self.loading) {
        return;
      }
      self.loading = true;
      self.airports = self.choosenAirports.concat(
        await flightAPI.getAirports(value)
      );
      self.loading = false;
    },
  },
  watch: {
    search(value) {
      debounce(this.makeSearch, 1000)(value, this);
    },
  },
};
</script>

<style>
.v-chip.v-size--default {
  display: none;
}

.adult:hover,
.child:hover {
  transform: scale(1.1);
  transition: transform 0.2s ease-in-out;
}

.adult:hover + .adultAction {
  display: block;
  color: red;
}
</style>
